# Class SimpleTypeVisitor8<R,P>

java.lang.Object
javax.lang.model.util.AbstractTypeVisitor6<R,P>
javax.lang.model.util.SimpleTypeVisitor6<R,P>
javax.lang.model.util.SimpleTypeVisitor7<R,P>
javax.lang.model.util.SimpleTypeVisitor8<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `TypeVisitor<R,P>`

Direct Known Subclasses:
  `SimpleTypeVisitor9`

@SupportedSourceVersion(RELEASE_8) public class SimpleTypeVisitor8<R,P> extends SimpleTypeVisitor7<R,P>
A simple visitor of types with default behavior appropriate for the `RELEASE_8` source version. Visit methods corresponding to `RELEASE_8` and earlier language constructs call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

API Note:
  Methods in this class may be overridden subject to their general contract.
Since:
  1.8
See Also:
  - Compatibility note for subclasses
  - `SimpleTypeVisitor6`
  - `SimpleTypeVisitor7`
  - `SimpleTypeVisitor9`
  - `SimpleTypeVisitor14`

- ## Field Summary

  ### Fields declared in class javax.lang.model.util.SimpleTypeVisitor6

  `DEFAULT_VALUE`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `SimpleTypeVisitor8()`
  Constructor for concrete subclasses; uses `null` for the default value.
  `protected`
  `SimpleTypeVisitor8(R defaultValue)`
  Constructor for concrete subclasses; uses the argument for the default value.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `R`
  `visitIntersection(IntersectionType t, P p)`
  Visits an intersection type.

  ### Methods declared in class javax.lang.model.util.SimpleTypeVisitor7

  `visitUnion`

  ### Methods declared in class javax.lang.model.util.SimpleTypeVisitor6

  `defaultAction, visitArray, visitDeclared, visitError, visitExecutable, visitNoType, visitNull, visitPrimitive, visitTypeVariable, visitWildcard`

  ### Methods declared in class javax.lang.model.util.AbstractTypeVisitor6

  `visit, visit, visitUnknown`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### SimpleTypeVisitor8

    protected SimpleTypeVisitor8()
    Constructor for concrete subclasses; uses `null` for the default value.

  - ### SimpleTypeVisitor8

    protected SimpleTypeVisitor8(R defaultValue)
    Constructor for concrete subclasses; uses the argument for the default value.
    Parameters:
      `defaultValue` - the value to assign to `SimpleTypeVisitor6.DEFAULT_VALUE`

- ## Method Details

  - ### visitIntersection

    public R visitIntersection(IntersectionType t, P p)
    Visits an intersection type.
    Specified by:
      `visitIntersection` in interface `TypeVisitor<R,P>`
    Overrides:
      `visitIntersection` in class `AbstractTypeVisitor6<R,P>`
    Implementation Requirements:
      This implementation calls `defaultAction`.
    Parameters:
      `t` - the type to visit
      `p` - a visitor-specified parameter
    Returns:
      the result of `defaultAction`